/*
 * Written by Alexey Vatchenko <av@bsdua.org>.
 * Public domain.
 */
#include <sys/types.h>

#include <gtk/gtk.h>

#include "tray-app.h"

void
trayapp_invert_pixbuf(GdkPixbuf *pixbuf)
{
	u_char *px;
	int width, height;
	int n_chan;
	int i, j, n;

	/* Do not support other BPS */
	if (gdk_pixbuf_get_bits_per_sample(pixbuf) != 8)
		return;

	px = gdk_pixbuf_get_pixels(pixbuf);
	width = gdk_pixbuf_get_width(pixbuf);
	height = gdk_pixbuf_get_height(pixbuf);
	n_chan = gdk_pixbuf_get_n_channels(pixbuf);

	n = n_chan;
	if (gdk_pixbuf_get_has_alpha(pixbuf))
		n--;

	for (i = 0; i < width * height; i++) {
		for (j = 0; j < n; j++)
			px[i * n_chan + j] = 0xff - px[i * n_chan + j];
	}
}
